Version 2.46.26 / 2022-03-04

- new code ATTL - definition of new linetypes (doc. see Codes and Formats/Attributes)
- new plugin Demo_gsrc (Geometric-Source-Relocatable-Code,
  - eg add object-source from extern)
- Bugfix Application-edit-symDir fixed
- minor bugfixes
- Russian removed

Programlines (C)  516820
Functions           5022


===========================================================================
Version 2.46.25 / 2022-01-19

- bugfix Modify_Linetype_display
- missing file ../ut/tstf__.c added
- build-scripts do, ../options.sh, ../init_examples.sh updated

Programlines (C)  515092
Functions           5003


===========================================================================
Version 2.46.24 / 2022-01-17

- adjust linewidth for UHD-screens
- new remote-control-code clear  (start new model - do not save active model)
- new remote-control-code system (do operating-system command, wait)
- new code DUMP (MAN and remote-control, dump objects, listt ..)
- new dev-tool TSTF (Demo_tstf_1 - do commands from file and rebuild plugin dynamic)
- minor bugfixes

Programlines (C)  531959
Functions           5001


===========================================================================
Version 2.46.22 / 2022-01-06

- Bugfix dxf-export-crash-bspl-surf
- Bugfix obj-export-bug-bspl-surf
- Bugfix stp-export-bug-file-format
- minor bugfixes

Programlines (C)  531949
Functions           4996

Release-Notes:
- some NVIDIA-drivers with Gtk3 cannot get OpenGL-Z-buffer;
  - use driver nouveau or use gcad-lib xa_gui_gtk2.so for Gtk2


===========================================================================
Version 2.46.20 / 2021-07-01

- Model-assembly-functions rewritten; subModels can be nested.
- Model-assembly accepts direct import of step, dxf, wrl, stl, 3ds, obj.
- Bugfix Cancel 2D-plane-definition
- Bugfix create-new-subModel
- Bugfix display-support-surface-conic
- DXF-export now can place 3D-oriented blocks (INSERT)
- STEP-export supports now some surfaces. Bodies not yet exported.
- default-directory for Applications (gcad-scripts .gcap) in symbolic directory "APPLI"
- config-files now in directory /cfg_<opsys>/ (was /cfg/) -
  - new: Standards/select directory-path-group (project-related-directory-groups)
- Modification of code for catalog-parts:
  - was eg |M20=CTLG "Profile/4x4_60"|
  - is now |M20="Profile/4x4_60.ctlg"|
    - remove "CTLG " before partname and add filetyp ".ctlg" to partname.

Programlines (C)  531397
Functions           4994


===========================================================================
Version 2.46.18 / 2020-11-05

- CAD Ellipse - option CW (clockwise) added
- CATALOG-parts can have subdirectories
- Joint can import plane for positioning submodel
- bugfix display of reversed Circle 
- bugfix select position gives wrong parameter for reversed curves
- bugfix polygonal representation of trimmed-polygon in contour 
- bugfix loft-surf with reversed curve
- bugfix insert points for "S Polygon < Points" (window GroupEdit)
- modification of trimmed curve for boolean surface operations
- functions Display/ObjNames ON and Display/ObjDirection ON rewritten

Programlines (C)  512798
Functions           4819


===========================================================================
Version 2.46.16 / 2020-05-26

- new NC-process-demo-model sample_PRC_cut1_4 (cut offset-curve)
- bugfix offset-curve "UT2D_2pt_int_ln_ci TODO I1"
- bugfix "MAN-type-menu  (left mouse button) covered"

Programlines (C)  498204
Functions           4776


===========================================================================
Version 2.46.14 / 2020-05-21

- symbolic directories support subdirectories
- redesign OpenGL-functions
- bugfix plane-definition 2020-05-19
- plugin DemoPlugin_Create updated (create objects from plugin)
- bugfix "unsupported language changed to english"
- many bugfixes

Programlines (C)  497252
Functions           4773


===========================================================================
Version 2.46.08 / 2020-04-04

- bugfix clothoid-parameter
- bugfix select-dynamic-symbol
- bugfix DL_alloc__-invalid-old-size
- bugfix startparameter-model+plugin

Programlines (C)  493507
Functions           4826


===========================================================================
Version 2.46.06 / 2020-03-31

- first updates for split surfaces

Programlines (C)  492519
Functions           4833


===========================================================================
Version 2.46.04 / 2020-02-21

- Bugfix "group-select-box not working" (Ctrl-leftMousbutton-drag selects group)
- Bugfix "defaultColor changed after subModel"
- Bugfix "CirPat.gcap Pointdefinition not yet implemented"
- Bugfix MS-Win OpenGL-Crash-Modsiz
- Internal Gtk-dialogs replaced by executable Gtk-dialogs
- zenity-dialogs replaced by executable Gtk-dialogs

Programlines (C)  476628
Functions           4825

===========================================================================
Version 2.46.02 / 2019-12-18

- MAN: new function "goto LineNr" with Ctrl-L
- MAN: new function "find text" with Ctrl-F
- new function "Search obj by objID" in Search/Name (button "edit")
- Bugfix "parametric-Point on polygon in compound-curve"
- Bugfix "find movable points" in CAD, sel. obj with right mouseB., "move-points"

Programlines (C)  473711
Functions           4822


===========================================================================
Version 2.46.00 / 2019-12-02

- CAD, MAN: bugfix "Point-referenced-X-Y-Z",  eg "P30=P(X(P20) Y(P20) Z(P32))"
- CAD, MAN: new function "intersect line-cylinder"
- CAD, MAN: lines tangent to circle from parameter or startPoint or endPoint;
            eg L26=L(C20 0.5)   L26=L(C20 MOD(1))   L26=L(C20 MOD(2))
- CAD: new function Variable = angle "V Angle line/vector" and "V Angle 2 lines/vectors"
- CAD: new function Circle from centerline and point on arc ("CIR Axis Point")
- CAD: new parameter "tilt-angle" for Plane "PLN PT Plane Offset Angle"
- CAD: redesign of geometry-engine; new codes SEG(), PTS(); PTI(); see CAD_Base_en.htm#fmt_dynamic-obj
- CAD: handling viewports added to menu "Display"
- new function 'select obj from objID' in menu Select
- Bug "autoscale mockup models wrl obj stl" fixed
- Installation- and Development-documentation updated (see Help / Documentation)

Programlines (C)  472776
Functions           4818


===========================================================================
Version 2.44.12 / 2019-07-11

- CAD: "A Revolved Surf" - support of trimmed curves added
- CAD: "A Extrusion Surf" - support of trimmed curves added
- CAD: bugfix 'cylindric-surfaces-height-from-parameter'

===========================================================================
Version 2.44.10 / 2019-06-20

- CAD: projection-plane added to View Top, Front, Side
- MAN: new function search-object (Ctrl-F)
- bugfix 'move-points_on_construction-plane'
- bugfix 'resize-window-smaller'
- bugfix 'CentOS-nan-crash'
- bugfix 'Debian-startup-hang-uname'


===========================================================================
Version 2.44 / 2019-04-10

- CAD: new offset-curves for all planar curves (for cutting, milling)
- CAD: Modify TRAnslate and TRAnform can use trimmed curves
- CAD: Curves "BSpline < convert & join obj's" can use trimmed curves
- RemoteControl: new command "WAIT_ESC" (wait until ESC-key is pressed)
- new startparameter "start remoteCommandFile"; see www.gCAD3D.org/doc/Settings_en.htm#Start

Programlines (C)  463510
Functions           4752


===========================================================================
Version 2.43 / 2018-11-16

- bugfix "gtk.h: no such file" for i586, i686
- new language (malai) added;


===========================================================================
Version 2.42 / 2018-10-16

- .deb and .rpm-packing reorganized, doc-directories changed,
- help-menu rewritten; new languages added;

===========================================================================
Version 2.41 / 2018-06-07

- new remote-command "exit"
- Bugfixes ("UME_alloc EOM" ..)

===========================================================================
Version 2.40 / 2018-06-07

- new function File/Open last-used;
- Startup-parameters changed, see www.gCAD3D.org/doc/Settings_en.htm#Start
- redesign of curves (for watertight-models curves now have polygon-files)
- new CAD-function "CurveEditor"; see  www.gCAD3D.org/doc/CVED_en.htm
- CAD-Translate with vector ("TRafo transl") option "keep parent" added
- new software-layout documentation www.gCAD3D.org/doc/SW_layout_en.htm

Programlines (C)  445885
Functions           3954



===========================================================================
Version 2.35 / 2017-04-18

- all curve-modifications (eg CUT) create now trimmed-curves
- all curves now have a polygonal representation
    (see www.gCAD3D.org/doc/watertight.htm)
- Format of message-files changed ({key} = {value}) for automatic translation

Programlines (C)  415388
Functions           3956



===========================================================================
Version 2.34 / 2016-10-05

- CAD - Plane definition extended. See www.gCAD3D.org/doc/CAD_PLN_en.htm#F2
- CAD - new symbol Arrowhead (N Symbol, symbolType 6)
- CAD - selection of catalogparts fixed
- CAD - Measure PT / Obj: normals to all types of curves added
- Menu Display: new option "Background white" (use eg with "save as JPG")
- automatic scaling (button "Scal.All") rewritten

Programlines (C)  431188
Functions           3956



===========================================================================
Version 2.32 / 2016-04-02

- new function: File /save Model as / JPG   (copy grafic-window)
- print-module: output of surfaces (by using http://www.geuz.org/gl2ps)
- new print-format PDF
- bugfix print PS

Programlines (C)  407808
Functions           3956



===========================================================================
Version 2.30 / 2016-03-16

- DXF-export: export subModels as BLOCKS
- DXF-import: import BLOCKS as subModels
- new plugin Demo_toolbar2
- CAD - provide vertex-position if analytic position cannot be computed
- CAD - bug "select ellipse in CCV" fixed
- CAD - bug "CUT" line with single cutting-obj fixed
- automatic support of all languages of installed messagfiles

Programlines (C)  406226
Functions           3956


===========================================================================
Version 2.28 / 2015-08-20

- new plugin Demo_toolbar1
- new plugin Demo_appDat1
- Undo output of applications and plugins with the UNDO-button
  Example: DemoPlugin_Dialog.c (func UNDO_app__)
- CAD "LN tangent to ..": parameter "unlimited" added
  "normal to construction-plane" bug fixed
- Bugfix GUI_file_open__ and GUI_file_save__
- GL_Do_Scale__ viewer bug with scroll fixed
- GUI_file_open_1 bug "no-selection" fixed
- Interaction bug "redo_Interaction" fixed
- development-docu for codes - formates  improved

Programlines (C)  346061
Functions           4927


===========================================================================
Version 2.26 / 2015-06-22

- Bug "translate concatenated-curve" fixed (sample_tra_ccv_1.gcad)
- Bug "modify GIS-point" fixed (sample_gis1.gcad)
- Bug "display html docu" (Linux only) fixed
- minor bugfixes
- modifications for git

Programlines (C)  336808
Functions           4917


===========================================================================
Version 2.24 / 2015-02-25

- NEW: License changed to GPL-v3; see Releasenotes.
- modifications for git
- minor bugfixes.

Programlines (C)  337156
Functions           4919

Releasenotes:
  Get sourcecode from github.com/gcad3d/gcad3d
    or from gCAD3D.org/download/gCAD3D_2.24-src.zip


===========================================================================
Version 2.22 / 2015-01-08
            
- Step-import: new functions and bugfixes
- dxf-export: export contours
- dxf-import: bug POLYLINES and rotation (code 50) with INSERT fixed
- structure of contour (CCV) completely changed.
- CAD-Measure can select vertex-points
- CAD-Interaction checkbox, can modify all numeric values
            
Programlines (C)  365495
Functions           4652
            
Releasenotes:
  Contour (CCV) structure changed: see struct CurvCCV (Typ_CVCCV)
    Change direction of contoursegments with REV (was CW).
  CAD-Interaction can modify all numeric values: see MODVAL in
    www.gCAD3D.org/doc/CAD_Activ_en.htm

            

===========================================================================
Version 2.20 / 2014-03-28

- CAD: sweep-surfaces new
- CAD: loft-surfaces (initially b-spline-surfaces)
- new: Step-export 
- Modify/Linetyp improved (see www.gCAD3D.org/doc/Attribs_en.htm)

Programlines (C)  355702
Functions           4575

Releasenotes:
  Sweep-surfaces: see www.gCAD3D.org/doc/format_gcad_A_en.htm#suswe
  Step-export AP203/ISO-10303-21:
    support for curves, surfaces; not yet colors, bodies.


===========================================================================
Version 2.14 / 2013-10-21

- new: dynamic modification of numeric values
- new: "find parent-objects" and "find child-objects"
- submodels: bug "load catalog-part" fixed


Programlines (C)  345729
Functions           4434

Releasenotes:
  "Modify numeric values" provides dynamic update of all parametric child-objects.
    Activation from the popup-menus (right mousebutton on object) in CAD or MAN.
    See video: http://youtu.be/q9WR7GRCWoY
  Find the parents or childs of parametric objects; this option was added to
    the popup-menus (activated with the right mousebutton) of the object in
    the display-window, in the browser-window and in the Search-window.
  Object-names are displayed in the object-browser.
  Applications: new dialogoptions CKB (checkbox) and RDB (radiobuttons), bugfixes.
    see www.gCAD3D.org/doc/Appli_en.htm
  V.2.141 - 2013-10-28:  bug CAD -> MAN fixed.


===========================================================================
Version 2.12 / 2013-09-07

- new: "Viewport" saves / restores active viewport
- DXF: new version Dxf-2000; import and export of SPLINE and ELLIPSE.
- OBJ: can import and export colors (.mtl - file).
- Modify/Surface color: select color from existing face as new active color
- Modify/SurfaceStyle: RCIR (planar 3 or 4-point-face) can also be set to symbolic
- Search/Name: find childs / parents of object; bugfixes. 
- CAD vector cartes: additional parameters rotation-angle, tilt-angle.


Programlines (C)  342650
Functions           4629

Releasenotes:
  Viewport: see www.gCAD3D.org/doc/VWR_en.htm#views
  Search/Name: see www.gCAD3D.org/doc/Search_en.htm
  CAD vector cartes: see www.gCAD3D.org/doc/CAD_Vec_en.htm
  Bug at startup with parameters fixed


===========================================================================
Version 2.10 / 2013-05-07

- new NC-processor PRC_cut1, postprocessor G-Code.
- CAD/Lines: tangents between circles/ellipses/b-splines
- CAD/Curves Ellipse from major Axis and point on the ellipse
- CAD/Vectors/VEC objects: get parallel tangent from curve, point on curve.
- CAD/Trim/CUT VEC objects: trim curves from parameters.
- Application: bug "update selection-input" fixed
- Catalog: bug "preview position" fixed


Programlines (C)  340271
Functions           4395

Releasenotes:
  New process-interface; see www.gCAD3D.org/doc/html/Process_en.htm.
  New NC-processor PRC_cut1; see www.gCAD3D.org/doc/html/PRC_cut1_en.htm,
    replaces the internal NC-processor.
  New tangent linees between circles/ellipses/b-splines:
    see  www.gCAD3D.org/doc/html/CAD_LN_en.htm#F5
  


===========================================================================
Version 2.01 / 2013-02-25

- CAD-Planes rewritten.
- Userapplication bug "cannot execute" fixed
- RemoteControl bugfixes
- new MS-Windows-version (XP and Win-7; 32 and 64-bit)
- new VisualBasic.Net testprogram for MS-Windows-RemoteControl 


Programlines (C)  313447
Functions           4293

Releasenotes:
  New functions for defining planes (see CAD/Planes).
    See www.gCAD3D.org/doc/html/CAD_PLN_en.htm
  RemoteControl-documentation:
    See www.gCAD3D.org/doc/RemoteControl_en.htm


===========================================================================
Version 2.00 / 2013-01-05

- new RemoteControl; see http://www.gcad3d.org/doc/html/RemoteControl_en.htm
- Bugfixes

Programlines (C)  312573
Functions           4250


Releasenotes:
  With RemoteControl you can control the cad-program from programs.
  All programming languages can be used, even shell-scripts.
  For input and output 2 pipes are used.
  Input and output is done with textcodes, not binary.



===========================================================================
Version 1.91 / 2012-12-05

- new Interface to Gtk3
- Step-import rewritten;
- CAD-Analysis-function now in toolbar "Measure"

Programlines (C)  309077
Functions           4208


Releasenotes:
 This version provides a new layer (C-KIT-GUI) between
   the application and gui-software (Gtk+)  and OpenGL.
 C-KIT-GUI has 2 shared libraries - Gtk2 and Gtk3.
 This makes the application independent from the GUI.
 C-KIT-GUI is OpenSource (http://www.gcad3d.org/gui/devdoc/index.htm).



===========================================================================
Version 1.82 / 2012-04-04

- problem get previous model at startup fixed
- problem change editor (Standards/Editor) fixed
- ruled surfaces - ellipses fixed
- file-chooser improved, deprecated gtk-functions removed
- "variable not found" when loading catalogparts fixed
- "Vektor undefined" for application-scripts fixed
- select object for application-scripts fixed

Programlines (C)   333815
Functions            3969



===========================================================================
Version 1.80 / 2012-01-20

- CAD-handling improved, direct help for the active CAD-inputfield
- many bugfixes
- new debian-package for Linux 32 and 64 - bit

Programlines (C)   328642
Functions            3971



===========================================================================
Version 1.70 / 2011-10-06


New:
- CAD-create B-Splines / join and convert into B-Splines handles points,
    lines, circles, polygons, ellipses and clothoids.
    see www.gCAD3D.org/doc/CAD_CV_en.htm#F8
- BSpline-surfaces also from trimmed spline-curves
- List of selected objects gives also parent-objects (eg of CUT-operations)
- Connection-lines (a new type of curve)
    see www.gCAD3D.org/doc/html/CAD_CV_en.htm#F9

Bugfixes:
- BSpline-surfaces: turns curves automatic if necessary
- edit points: insert points into polygon / b-splines fixed
- Linux-64: Function "Group / save group --> file" fixed
- Error exporting large surfaces (OBJ, STL, VR) fixed
- Errorhandling improved
- Undo fixed for objects on construction-plane
- getting-started-documention updated
    see www.gCAD3D.org/doc/html/CAD_examples_en.htm


Programlines (C)   322070
Functions            3900



===========================================================================
Version 1.64 / 2011-07-21

New:
- joints - import of objects from subModels;
    see www.gCAD3D.org/doc/html/CAD_Jnt_en.htm
- new grid showing active constructionplane 

Bugfixes:
- CAD-handling improved
- CAD-"move points" improved
- Settings Display/PointDisplay-OFF und PlanesDisplay-OFF are stored in model
- SVG-Export: stroke-width, font-size fixed.

Devel:
- DemoPlugin_Create.c updated


Programlines (C)   317590
Functions            3856



===========================================================================
Version 1.62 / 2011-05-15

New:        
- Application "3Dfrom2D" (create 3D-models from 2D-drafts)
    see www.gCAD3D.org/devdoc/ApplicationData.htm
- Demo_CPP is a new plugin made in C++ (using gcad-functions from a cpp-plugin)

Bugfixes:
- test for max. texturesize
- many bugfixes for MS-Win 


Programlines (C)   308203
Functions            3832



===========================================================================
Version 1.60 / 2011-04-02


New:        
- search objects renewed: find searchpatterns and/or depending objects
    (checkbox "Search/Name" or Ctrl-F; www.gCAD3D.org/doc/Search_en.htm)
- ApplicationData - plugins can store applicationspecific data here
    (www.gCAD3D.org/devdoc/ApplicationData.htm)
- ApplicationObjects - plugins can create applicationspecific objects
    (also OpenGL-objects; www.gCAD3D.org/devdoc/ApplicationData.htm)
- development-package and documentation updated
    (www.gCAD3D.org/devdoc/index.htm)
    (www.gCAD3D.org/??/dev??.zip)
- Microsoft 64-bit: works now if you do not install
    on the (write-proteced) systemdrive C.


Bugfixes:   
- automatic reload of plugins fixed

Anzahl Programmzeilen   307627
Anzahl Funktionen         3787



===========================================================================
Version 1.58 / 2011-02-22

New:        
- load also images with 8-bit-colors (until now only images with 24-bit-colors)




===========================================================================
Version 1.56 / 2011-01-22


New:        
- Civil-Engineering-application APP_GIS1: breaklines and void areas added
    see www.gCAD3D.org/doc/APP_GIS1_de.htm
- new CAD-function to define the orientation of submodels by rotationangle
    see www.gCAD3D.org/doc/CAD_Model_de.htm#F0

Bugfixes:   
- ScaleAll - bug fixed.
- 64-bit: DispListAllocation-bug fixed.
- VRML2-export, VRML2-import bugfixes.

Anzahl Programmzeilen   305892
Anzahl Funktionen         3757



===========================================================================
Version 1.54 / 2010-11-07

New:        
- multiselection of a group of objects with the mouse
  see www.gCAD3D.org/doc/GROUP_en.htm)
            
Bugfixes:   
- using keycodes improved, dokumentation improved
  see www.gCAD3D.org/doc/VWR_en.htm
  see www.gCAD3D.org/doc/CAD_en.htm
  see www.gCAD3D.org/doc/gCAD3D_startMAN_en.htm
            
Anzahl Programmzeilen   304046
Anzahl Funktionen         3697


===========================================================================
Version 1.52 / 2010-10-10

New:        
- Export SVG (IO_svg_de.htm, IO_svg_en.htm)

Bugfixes:   
- 

Anzahl Programmzeilen   302727
Anzahl Funktionen         3655


===========================================================================
Version 1.50 / 2010-06-21
         
New:        
- Measure-Function (main-menu; checkbox "Measure")
- TextureEditor. Select surface with right mousebutton, select "texture".
    Move / zoom textureimage with mouse.
- Programdirectories can be redirected in startscript (Linux only)
- Print: white background ..
            
Bugfixes:   
- OBJ-export: bug "missing triangles" fixed.
- PointEditor: pointselection improved 
- dxf-import: buffersize increased
- selection of points improved
- Print-MS: prints to network-printers
- many bugfixes ..

Anzahl Programmzeilen   326070
Anzahl Funktionen         3616


===========================================================================
Version 1.46 / 2010-03-27

New:
- new Linux 64-bit version (Linux: 64- and 32-bit; Microsoft: 32-bit).
- import DXF-Files:  import also rounded Polylines.
- plugin-directories are binMS32 and binLinux32 and binLinux64 (until now bin)

Bugfixes:
- Step-import: bug with rational b-splines fixed.
- display CAD-helpfiles with firefox: bug fixed.




===========================================================================
Neu in Version 1.44 / 2010-02-18

New:
- VRML-2-Import (no Animations, textures not yet)
- tooltips and messages spanish/french/italian

Bugfixes:
- MS-Windows: import-textures-bug fixed
- MS-Windows: successful tested on Windows-7
- MS-Windows: now using MinGW (until now Micosoft Visual-C)
- VRML-1 Import an Cadenas Partserver angepasst

Anzahl Programmzeilen   311360
Anzahl Funktionen         3250




===========================================================================
Neu in Version 1.42 / 2010-01-15

New:
- all tooltips internationalized (de / en)
- CAD: PointEditor (move points of curves (lines, polygons, splines ..),
       all depending objects are updated dynamically)
- decode and view objects with popup-menu-function "inspect" (right mouse-button)

Bugfixes:
- import OBJ-Files (Wavefront): support for newer Format (blender, SweetHome3D)
- CAD: Undo and Redo completely rewritten.


Anzahl Programmzeilen   308621
Anzahl Funktionen         3217



===========================================================================
Neu in Version 1.40 / 2009-11-13

New:
- Browserwindow (treeview of all objects) 
- object-specific popup-menus for selections (with the right mouse-button)
    in the Graficwindow and in the Browserwindow 

Bugfixes:
- STEP-Import: bug in STP_r_alloc_tab fixed
- Startup-problem with textured models fixed
- problem translate-object-by-vector fixed


Anzahl Programmzeilen   302033
Anzahl Funktionen         3117



===========================================================================
Neu in Version 1.34 / 2009-09-08

Bugfixes:
- Linux: using libgtkglext (before libgtkglarea)


Anzahl Programmzeilen   289249
Anzahl Funktionen         3010



===========================================================================
Neu in Version 1.32 / 2009-08-29

New:
- CAD: select-options with middle mousebutton
- redefine Help-Browser, Editor (Menu / Standards)

Bugfixes:
- CAD: INTersect and CUT completely rewritten.


Anzahl Programmzeilen   295548
Anzahl Funktionen         3032




===========================================================================
Neu in Version 1.30 / 2009-07-15

Bugfixes:
- DXF-Import completely rewritten.
- italian docu - partially


Anzahl Programmzeilen   289249
Anzahl Funktionen         3010




===========================================================================
Neu in Version 1.28 / 2009-06-03


New:
- new userdocumentation (only german - not yet translated)
- new developer-documentation (with Doxygen, english)

Bugfixes:
- memory leak fixed


Anzahl Programmzeilen   264235
Anzahl Funktionen         3001




===========================================================================
Neu in Version 1.26 / 2009-03-05

New:
- CAD: create parametric points at selection of surface
- MS-Win: Portierung auf Express-2008-Compiler (VC9)

Bugfixes:
- segment-faults at startup fixed for Puppy-Linux

Anzahl Programmzeilen   261093
Anzahl Funktionen         3002




===========================================================================
Neu in Version 1.24 / 2008-11-13

neu:
- curve from intersection surface x surface (CAD/INT intersect)

Bugfixes:
- formulaInterpreter: problem with "((" fixed
- bug "cannot support textures" fixed
- bug export subModels as VRML-1 and VRML-2 fixed

Anzahl Programmzeilen   259451
Anzahl Funktionen         3002




===========================================================================
Neu in Version 1.2 / 2008-10-09

neu:
- CAD-Search/Name: objectList for all kinds of objects
- objectList: define name or info for object; search for names/infos
- objectList: search for names/infos (filter objects)
- popup-menu in objectList (right mousebutton)
    (modify name, modify object, delete object)

Bugfixes:
- CAD-Modify/Delete: display depending Lines fixed

Anzahl Programmzeilen   257561
Anzahl Funktionen         3125




===========================================================================
Neu in Version 1.18 / 2008-09-07

neu:
- use jpg-images for textures,
- intercative modification of scale/position of textures
    (see Help / Textures)
- MS-Win: new GTK-Version 2.12;

Anzahl Programmzeilen   255966
Anzahl Funktionen         2961





===========================================================================
Neu in Version 1.16 / 2008-08-12

neu:
- Anwendungsprogramme mit Eingabeformularen (siehe Help/Application)
  Applicationprogramming with Inputforms (see Help/Application)

Anzahl Programmzeilen   253393
Anzahl Funktionen         2925




===========================================================================
Neu in Version 1.146 / 2008-06-04

neu:
- CAD: Project objects along vector onto plane (Project obj)
- FormulaInterpreter: new functions ASIN ACOS ATAN
- FormulaInterpreter: new function 'raise to power' with ^

Bugfixes:
- CAD: Circle "C = ARC point point radius" korrigiert
- FormulaInterpreter rewritten,  operatorpriority corrected
- import Landmark-XML: point-not-defined bug fixed.

Anzahl Programmzeilen   249310
Anzahl Funktionen         2862




===========================================================================
Neu in Version 1.144 / 2008-03-01

neu:
- Userapplication APP_GIS1 with the following functions:
- GIS-function: import, modify, export Ascii-GIS-pointfiles
- GIS-function: create mesh ("TIN") from points

Anzahl Programmzeilen   245249
Anzahl Funktionen         2800




===========================================================================
Neu in Version 1.142 / 2008-01-18

neu:
- Documentation translated into English
- OpenGL-Viewer: speed with large meshes improved
- First Animation/Kinematik-Demoprogram (plugin)
- tested with Mandrake-2008 Ubuntu-7.10 OpenSuse-10.3

Anzahl Programmzeilen   241468
Anzahl Funktionen         2735




===========================================================================
Neu in Version 1.14 / 2007-12-04

neue Funktionen:
- CAD: Circle tangential to 3 Objects
- Documentation translated into English (~ 50 %)
- Development-Package: Functionheaders & Description (see DevelTools.txt)

Bugfixes:
- CAD: Circle tangential to 2 Objects + Radius rewritten

Anzahl Programmzeilen   240265
Anzahl Funktionen         2735




===========================================================================
Neu in Version 1.12 / 2007-10-20

neue Funktionen:
- import Mesh from Landmark-XML-Files
- create Clothoid-Curve
  (see CAD - "S Clotoid" - Help)
- compress/decompress native modelfiles (with gzip)
- 1-n Objekte zu B-Splinekurve verbinden
  (see CAD - "S BSpline < join obj's" - Help)
- Circ from startpoint, tangent and radius
  (see CAD - "ARC PT Tang Radius Angle" - Help)
- Vectors tangential to curves
  (see CAD - "VEC tangent. (Circ, Elli, Bsp, Cloth) - Help"
- import mesh from Landmark.xml - files

Bugfixes:
- Iges-Import-Bug with Qmax/Qflex3D-files fixed
- VRML2-Export-Bug with big surfaces fixed
- DXF-Import-Bug limiting to 10000 input-objects fixed.

Anzahl Programmzeilen   236640
Anzahl Funktionen         2703




===========================================================================
Neu in Version 1.100 / 2007-09-01



neue Funktionen:
- Delete/Restore-Funktionen neu implementiert
  (Ctrl-Z = Delete,  Ctrl-Y = Restore)
- Konstruktionsebene (ConstructionPlane, UserCoordinateSystem) neu in CAD
  (CAD - "PLN ..", "ActiveConstrPlane", "Reset ConstrPlane")
- B-SplineKurven exact durch Definitionspunkte
  (CAD - "S BSpline < Points...")
- Freiformflaechen durch Querschnittkurven
  (CAD - "A BSplSur < Curves across")
- Freiformflaechen durch Laengs- und Querschnittkurven
  (CAD - "A BSplSur < Curves along/across")
- Freiformflaechen durch 4 oder 3 Randkurven
  (CAD - "A BSplSur < Curves along/across")
- B-SplineKurven aus isoparametrischen Flaechenkurven
  (CAD - "ISOparametric Curve from Surf" (Menu CUT..))
- Projektion Punkt auf Freiformflaeche
  (CAD - "PT Proj. PT -> LN/CIR/CRV/PLN/SUR")
- Schnittpunkt Linie / Freiformflaeche
  (CAD - "PT intersect  LN/CIR/CRV/PLN/SUR")

Anzahl Programmzeilen   232442
Anzahl Funktionen         2638



===========================================================================
Neu in Version 1.084 / 2007-07-07

geändert:
- Iges-Import from AutoDesk-Inventor



===========================================================================
Neu in Version 1.082 / 2007-06-17

geändert:Butt
- Fehler bei CATALOG korrigiert



===========================================================================
Neu in Version 1.08 / 2007-05-08

neue Funktionen:
- Normteilbibliotheksfunktionen Catalog (Catalog_de.htm)
- Modify subModelPosition (Translate/Rotate/Surface-to-Surface)
- Export im Format STL; subModels werden exploded (f. Blender)
- WRL-Export: es werden auch Mockup-subModels (wrl,stl,..) exportiert
- neue Funktion WRITE/CALL zur Erzeugung von Parametrikmodellen (gCAD3D_de.htm)
- neue Konstante Variablen (RAD_1 SR_3 .. siehe Doku Variablen)
- Linuxversion nun mit gcc4.1.1
Fehlerkorrekturen:
- Fehler bei JUMP in subModels korr.
- alle DLL's (.so) nun im Unterverzeichnis bin

Anzahl Programmzeilen   238692
Anzahl Funktionen         2556



===========================================================================
Neu in Version 1.06 / 2007-03-27

neue Funktionen:
- Import STL-Files (Ascii)
- neue interaktive Help-Funktion fuer CAD
- Dateityp ".dat" fuer das native Format geaendert in ".gcad"
- Samplemodell fuer texturierte Flaechen.
- Fehler MS-Win CAD-GruppenEingabe korrigiert
- MS-Win: Portierung auf Express-2005-Compiler (VC8)
- MS-Win: Portierung auf GTK-Version 2.10

Anzahl Programmzeilen   216576
Anzahl Funktionen         2624



===========================================================================
Neu in Version 1.04 / 2007-01-01

neue Funktionen:
- Intersection Surface X Plane
- KeyIn Objektname bei Dump/Obj und Group/Add
- Linux: erste Version mit Installer gxInstall.
- Fehlerkorrekturen.

Anzahl Programmzeilen   211651
Anzahl Funktionen         2487



===========================================================================
Neu in Version 1.02 / 2006-09-13

neue Funktionen:
- Texturen auf Flaechen legen
- VRML2-Export (VRML-97; noch keine Texturen, noch kein VRML2-Import)
- DXF-out: Flaechen werden als 3DFACE's exportiert (nicht subModels)
- interaktiv Farbe und Transparenz fuer Flaechen setzen
- neues Objekt 3D-Dimension (NOTE N DIM3)
- neues Objekt Note mit 3D-Punktkoordinaten (N PointPos; N=LDRP)
- neues Objekt Note mit Kreis (N Text,LN,Circle; N=LDRC)
- neues Objekt Symbol Stern, .. Vektoren (N Symbol; N=LDRS)

geändert:
- BlockNote (N=TAG); Parameterreihenfolge geaendert.

Anzahl Programmzeilen   209117
Anzahl Funktionen         2635



=========================================================================
Neu in Version 1.00 / 2006-05-10

neue Funktionen:
- CAD: Linetyp interaktiv modifizieren
- CAD: SurfaceStyle (shaded od. symbolic)  interaktiv modifizieren
- CAD: Parametrische Definition für Punkte auf Line,Circ, Curve.
- CAD: Parametrische Definition für Segmente von Polygon, CCV.
- VRML1-Export von Submodellen (Assemblies)

geändert:
- Displayprobleme bei modifizierten Elementen (CUT ..) korrigiert
- NC-Replay-Fehler korrigiert.
- STEP-Import: Fehler bei sehr grossen Modellen korrigiert

Anzahl Programmzeilen   201785
Anzahl Funktionen         2547




==========================================================================
Neu in Version 0.98 / 2006-02-24

neue Funktionen:
- STEP-Import: Assemblies und Rational-B-SplineCurves/Surfaces;
- VRML1-Export: Assemblies (subModels).
- Interaktiv: Gruppe bilden und (native) exportieren.
- Interaktiv: Circ - neue Funktionen

geändert:
- Keyword MOCK obsolet
- Fehlerkorrekturen ..

Anzahl Programmzeilen   197887
Anzahl Funktionen         2528




==========================================================================
Neu in Version 0.96 / 2005-11-10

neue Funktionen:
- STEP-Import (ISO-10303-21 - AP203/AP214). Getestet mit CATIA-V4 und CATIA-V5.
  Noch nicht unterstützt: Rational-B-SplineCurves.
- CAD-Funktion Prisma (Solid)

geändert:
- VRML1: Problem zu grosse Importmodelle korr.
- Fehlerkorrekturen bei Tesselate und Export VRML1.

Anzahl Programmzeilen   182424
Anzahl Funktionen         2349



==========================================================================
Neu in Version 0.94 / 2005-06-17:

Korrigiert 2005-08-08:
- MS-Win: Fehler bei Installation in Verzeichnisse mit blanks im Namen

neue Funktionen:
- MS-Win: NISI-Installer
- Parallelogramm  (S=RECT vec1 vec2)
- Solids: Kugel (B=SPH center radius)
- Solids: Prisma von Parallelogramm (B=PRISM parallelogramm vektor)
- VRML1: Sphere und Cone.

geändert:
- Linux: GTK+2 (bisher GTK+1.2); gtkglarea statisch gelinkt.
- MS-Win: GTK+2 + GtkGLExt (bisher GTK+1.2 + gtkglarea)
- Fehlerkorrektur bei Import VRML1 und Import Iges
- Fehlerkorrektur bei NC (siehe Modell sample_nc0.dat)

Anzahl Programmzeilen   165485
Anzahl Funktionen         2151




==========================================================================
Neu in Version 0.93 / 2005-05-11:

neue Funktionen:
- Symbole als selektierbare Objekte (N=TAG ..)

geändert:
- Fehlerkorrektur bei Import VRML1 und Import Iges
- Fehlerkorrektur bei Import Bitmaps (padding)
- Fehlerkorrektur bei Export Mockup (VRML1, OBJ, TESS)

Anzahl Programmzeilen   163254
Anzahl Funktionen         2080




==========================================================================
Neu in Version 0.92 / 2005-04-11:

neue Funktionen:
- Import/Export von VRML-1-Files als Mockup-Modelle (nur FaceSets)
- Import/Export von WaveFront-OBJ-Files (nur Faces)
- Interaktionen können mit allen Darstellungsobjekten verbunden werden
- Interaktion Modellaufruf (wie HTML - HREF)
- Interaktion Programmaufruf (Plugin starten)
- Interaktion Ansichtsposition (Viewport) verändern
- Transformation von Kurven und Flächen (Translation, Rotation, Transformation)
- Transformation in anderes Referenzsystem
- Transformation aus Referenzsystem in das Hauptachsensystem
- Darstellung von Bitmaps (nur uncompressed BMP-Files)
- Toolbar und Messagebar können ausgeblendet werden (Vollbild)

geändert:
- Aufbau der Flächen vom Typ_SURCIR und Typ_SURSTRIP
- Bitmap-Notes; "N#=TXA .." ersetzt durch "N#=TAG 0 .."

Anzahl Programmzeilen   160773
Anzahl Funktionen         2060



==========================================================================
Neu in Version 0.90 / 2004-12-30:

neue Funktionen:
- Iges/Dxf-Modelle können als Startparameter angegeben werden (aus Filebrowser)
- neuer Funktionsmodul "Viewer"
- File/Open: DXF/IGS - Modelle werden nun automatisch importiert.
- Dimensions fertiggestellt (Linear-, Winkel-, Radiusvermaßung)
- Texte: Sonderzeichen, Textsize nun in den Defaults.
- CAD-Funktion Suchen/Löschen/Modifizieren verbessert
- CAD: direkte Selektion von Objektendpunkten, Polygonpunkten ..
- DXF-Import von LWPOLYLINE u DIMENSION u MTEXT
- neue Kreisdefinition:Circ = Mittelpunkt Startpunkt Drehwinkel Z-Achse

geändert:
- Definition Alfatext   (N#=TXA <Position> <Text>    -    TXA kommt dazu)
- Kreisdefinition Circ = Mittelpunkt Radius:    -   Z-Achsvektor hinzu ("DZ").
- struct Dimen: char dtyp zu.



Noch nicht implementierte Funktionen:
- Erzeugen von B-Spline Flächen (dzt nur via Import Iges)
- Funktionen zur Erzeugung von Schnittkurven von Flächen
- gelochte Schraffuren
- Zeichnungsableitung 2D -> 3D


Anzahl Programmzeilen   147630
Anzahl Funktionen         1907




==========================================================================
Neu in Version 0.86 / 2004-10-10:


neue Funktionen:
- Viewer: Mittelpunkt für 3D-Rotation durch Selektion eines beliebigen Vertex
- CAD: RevolutionSurfaces (Rotationsflächen)
- CAD: Funktion CUT (trimmen von linearen Elementen)
- CAD: Funktion TRANSLATE (verschieben / drehen von linearen Elementen)
- CAD: Funktion PROJECT (lineare Elemente auf Ebene projizieren)
- CAD: Funktion MIRROR (lineare Elemente um Ebene spiegeln)
- CAD: Analysefunktionen (Objekt dekodieren,  Abstand / Normalabstand messen)
- Iges-Import: Getrimmte, gelochte RuledSurfaces (144 - 118) und
               getrimmte, gelochte RevolutionSurfaces (144 - 120).
- Iges-Export: B-Spline Flächen Ent. 128 und Rev.Surfaces, Ent. 120.
- DXF-Export: Ellipsen und B-Spline-Kurven werden als POLYLINE ausgegeben.


geaendert:
- Objekttyp "T" zur Definition geometr. Transformationen (war ToolDef).
- struct Circ: Oeffnungswinkel ango zugefuegt


Anzahl Programmzeilen   140173
Anzahl Funktionen         1808



==========================================================================
Neu in Version 0.84 / 2004-07-08:

neue Funktionen:
- begrenzte, gelochte Flaechen mit Stuetzflaeche (Ruled, B-Spline,
  Konisch Toroid).


geaendert:
- Definition f. gelochte planare Flächen


Anzahl Programmzeilen   126304
Anzahl Funktionen         1734



==========================================================================
Neu in Version 0.82 / 2004-04-30:

neue Funktionen:
- Planare gelochte Flaechen aus CIRC / Ellipse / B-Spline / CCV (A = FSUB)
- Iges-Import u. Export von planaren gelochten Flaechen (Ent. 144,142,102)
- automatisches Vergroessern aller Datenfelder (realloc)
- automatisches Laden von Modellen / Programmen (durch Startparameter)


geaendert:
- Alle zur Entwicklung von Zusatzprogrammen erforderlichen Files in
  Paket -devel- ausgelagert.


Anzahl Programmzeilen   123107
Anzahl Funktionen         1579





==========================================================================
Neu in Version 0.80 / 2004-02-02:

neue Funktionen:
- interne und externe Submodels
- Konstruktionsebene frei definierbar
- neue Iges-Import-Elemente 118,122,144,308,408
- neue Iges-Export-Elemente 118,308,408
- RuledSurface aus Grundelement und Vektor


geaendert:
- Startupfile nun <base>tmp/Model_ (war <base>tmp/xa.apt)
- File/Open nur auf Verzeichnisse in Datei <base>/xa/dir.lst
- Definition Torus abgeaendert


Anzahl Programmzeilen   117749
Anzahl Funktionen         1509





==========================================================================
Neu in Version 0.77 / 2003-11-14:

Neue Plattform MS-Windows.

neue Funktionen:
- neue Printertreiber (Postscript(Vektoren), PCL5(via GL), HPGL).

Programming:
- neues Beispiel Postprozessor (DemoPostProc.*, mit Sourcecode).
- struct Ellipse geaendert in struct CurvElli (VC98\include\wingdi.h) !!
- struct Polygon geaendert in struct CurvPoly (VC98\include\wingdi.h) !!



==========================================================================
Neu in Version 0.74 / 2003-09-15:

- CAD_Interface fuer planare Flaechen, Flaeche auf Konus, Flaeche auf Torus
- CAD-Interface fuer die Objekte Konus, Torus.
- Darstellung getrimmter Flaechen durch integrierte Dreieckszerlegung
  (Tesselation) fuer planare Flaechen, Flaechen auf Konus, Flaechen auf Torus.
- Auswahlmenue (Popup) bei Selektion graf. Objekte, wenn mehrere Objekte
  genau uebereinander liegen.
- CAD-Interface fuer neue Funktion Schraffur (Menue Flaechen - S)
- Eingabefenster f. div. Toleranzwerte (Standard/Tolerances)
- Definition Drehmittelpunkt (ViewZ) verbessert.
- Fehler beim Resolv Contours korr.
- Lizenzhinweis LGPL entfernt (Sourcecode nur teilweise frei)




==========================================================================
Neu in Version 0.72 / 2003-08-04:

- Schnittpunkte Circ/B-Spline, Circ/Ellipse, Ellipse/Ellipse, Ellipse/B-Spline.
- interaktives Objekt Polygon (im Menü Kurven - S)
- proj. PT -> Polygon, Tangente an Polygon
- Schnittpunkte Polygon - Line, Circle, Ellipse, B-Spline, Polygon.
- Kreise: Bei Vollkreisen mit Z-Vektor nach -Z nun Z-Vektor immer nach +Z
  (dadurch alte Konturen aus V0.70 tw. defekt)


================================== EOF ====================================
